<template>
  <div class="toaster">
    <div v-for="(toast, index) in toasts" :key="index" class="toast">
      <sa-caption :text="toast.message" :type="toast.type" />
      <span class="hide" @click="hideToast(toast)">
        <sa-icon icon="x" />
      </span>
    </div>
  </div>
</template>

<script>
export default {
  name: 'SaToaster',
  props: {
    /** Array of toast messages currently displayed */
    toasts: {
      type: Array,
      default: () => []
    }
  },
  methods: {
    hideToast(toast) {
      this.$emit('closedtoast', toast)
    }
  }
}
</script>

<style lang="scss" scoped>
.toaster {
  position: fixed;
  right: spacing(2);
  top: spacing(2);
  display: flex;
  flex-direction: column;
  align-items: flex-end;
  .toast {
    display: flex;
    align-items: center;
    padding: spacing(1);
    background: white;
    border: border(grey-light);
    border-radius: $border-radius;
    & + .toast {
      margin-top: spacing(1);
    }
    .hide {
      margin-left: spacing(1);
      cursor: pointer;
      color: color(grey);
    }
  }
}
</style>
